#include <stdio.h>
#include <stdint.h>
#include <osbind.h>

struct {
    uint16_t fc;
    uint32_t addr;
    uint16_t instr;
    uint16_t stat;
    uint32_t pc;
     int32_t offs;
} exc;

void testcode(void)
{
    __asm volatile(
      "move.l   sp,a4\n"        // save stack pointer
      "move.l   8.w,a5\n"       // save bus error handler
      "move.l   #2f,8.w\n"      // set bus error handler
      //"moveq    #0,d0\n"
      //"lea      0x401234,a0\n"
      //"move.l    #0x400000,d0\n"
      "1:\n"
      "jsr      0x401234\n"     // trigger bus error
      //"jsr      0xffffffe0.w\n"     // trigger bus error
      //"jsr      4(a0,d0)\n"
      //"jsr         0(pc,d0)\n"
      
      "2:\n"                    // bus error handler
      "move.w   (sp),%0\n"      // function code
      "move.l   2(sp),%1\n"     // access address
      "move.w   6(sp),%2\n"     // instruction code
      "move.w   8(sp),%3\n"     // status register
      "move.l   10(sp),%4\n"    // program counter
      "move.l   %4,%5\n"
      "sub.l    #1b,%5\n"       // offset PC to JSR
      
      "move.l   a5,8.w\n"       // restore bus error handler
      "move.l   a4,sp\n"        // restore stack pointer
      : "=r"(exc.fc), "=r"(exc.addr), "=r"(exc.instr), "=r"(exc.stat), "=r"(exc.pc), "=r"(exc.offs)
      : : "a0","d0", "a4","a5","memory");
      
}

int main(void)
{
    long oldssp = Super(0ul);
    
    testcode();
    printf("Misc:\t$%04x\r\n", exc.fc);
    printf("Addr:\t$%08lx\r\n", exc.addr);
    printf("Instr.:\t$%04x\r\n", exc.instr);
    printf("SR:\t$%04x\r\n", exc.stat);
    printf("PC:\t$%08lx\r\n", exc.pc);
    printf("Offs:\t%ld\r\n", exc.offs);
    
    SuperToUser(oldssp);
    return 0;
}